<?php

function dice_info() {
  $object = new StdClass();

  $object->name     = t('Dice Rolling');
  $object->author   = 'Morbus Iff and Aaron Winborn';
  $object->email    = 'morbus@disobey.com';
  $object->url      = 'http://www.gamegrene.com/forum/53';
  $object->modified = '2006-02-06';
  $object->version  = 0.2;
  $object->description_short = t('(REQUIRED) This plugin offers simple dice rolling functions which are used throughout the GameAPI\'s Default Engine, using notation any tabletop roleplayer most assuredly recognizes. It allows the standard "3d6" (i.e., "roll three six sided dice"), and also "3^5d6+1" (i.e. "roll five six sided dice, keep the highest three, and add 1"). Future updates will include other common dice rolling mechanics.');
  $object->description_long  = "<p>$object->description_short</p>";

  return $object;
}

/**
 * Roll dice and return the sum. Simple enough, eh?
 *
 * The only parameter is a string in traditional RPG dice notation. Examples
 * include 4d6, 3d8, 3^5d6 (weighted, taking the highest 3 of 5 dice rolled),
 * 1d100+50, 6d6-6, 1d50+50*4-1, and so on and so forth.
 */
function dice($notation) {

  // remove whitespace and turn "x" to "*".
  $notation = str_replace('x', '*', $notation);
  $notation = preg_replace('/\s/', '', $notation);

  // if we're keeping high rolls, find out how many and store in $keep_highest.
  if (strstr($notation, '^')) { list($keep_highest, $notation) = explode('^', $notation); }

  // split our notation on the "d". nothing magical.
  list($num_rolls, $remainder) = explode('d', $notation);

  // if there are operations to be done after the dice roll,
  // split at the first one so we can get the number of sides,
  // and save the rest into $modifiers for eval()ing later on.
  if (preg_match('/^\d*([\+\-\*\/])/', $remainder)) {
    $matches = preg_split('/([\+\-\*\/])/', $remainder, -1, PREG_SPLIT_DELIM_CAPTURE);
    $num_sides = array_shift($matches); $modifiers = implode('', $matches);
  } else { $num_sides = $remainder; $modifiers = NULL; }

  // roll however many times necessary and $keep_highest as needed.
  for ($ctr = 0; $ctr < $num_rolls; $ctr++) { $virgins[] = rand(1, $num_sides); }
  if (isset($keep_highest)) { rsort($virgins); $virgins = array_splice($virgins, 0, $keep_highest); }
  $rolling_result = array_sum($virgins);

  // eval is simply easiest here so if we have to run one,
  // we'll remove anything not a number or math-related.
  if (isset($modifiers)) {
    $modifiers = preg_replace('/[^(\d|\+|\-|\*|\/|\(|\))]/', '', $modifiers);
    eval("\$final_result = $rolling_result $modifiers;"); // ssshShHhh.
  } else { $final_result = $rolling_result; }

  return $final_result;
}

